package MyIceModule;

public class l1 {
    public static void main(String[] args)
    {
        l1 lgd = new l1();
        lgd.run(args);
    }

    void run(String[] args)
    {
        int status = 0;
        Ice.Communicator ic = null;
        try {
            ic = Ice.Util.initialize(args);
            Ice.ObjectAdapter adapter = ic.createObjectAdapter("l1");
            Ice.Object object = new l1I();
            adapter.add( object, Ice.Util.stringToIdentity("l1"));
            System.out.println("l1: Activating");
            adapter.activate();
	    System.out.println("l1: Waiting for shutdown");
            ic.waitForShutdown();
	    System.out.println("l1: Got shutdown");
        } catch (Ice.LocalException e) {
            e.printStackTrace();
            status = 1;
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
            status = 1;
        }
        if (ic != null) {
            try {
		System.out.println("l1: calling Communicator::destroy");
                ic.destroy();
		System.out.println("l1: return from Communicator::destroy");
            } catch (Exception e) {
                e.printStackTrace();
                status = 1;
            }
        }
        System.out.println("l1: exit with "+status);
        System.exit(status);
    }

    class l1I extends _l1interfaceDisp {
        public String l1(String rs, Ice.Current current)
        {
            System.out.println("l1: l1I::l1 entered");
            Ice.Communicator ic=current.adapter.getCommunicator();
            String proxystring = "l2@l2.l2"; 
            System.out.println(
                "l1: The proxystring is "+proxystring);
            Ice.ObjectPrx base = ic.stringToProxy(proxystring);
            l2interfacePrx prx = l2interfacePrxHelper.checkedCast(base);
            if(prx ==null) {
                System.out.println(
                    "l1: Invalid Proxy:"+proxystring);
                    throw new Error("Invalid proxy");
            }
            return prx.l2(rs);
        }
    }
}
