package MyIceModule;

public class l3 {
    public static void main(String[] args)
    {
        l3 lgd = new l3();
        lgd.run(args);
    }

    void run(String[] args)
    {
        int status = 0;
        Ice.Communicator ic = null;
        try {
            ic = Ice.Util.initialize(args);
            Ice.ObjectAdapter adapter = ic.createObjectAdapter("l3");
            Ice.Object object = new l3I();
            adapter.add( object, Ice.Util.stringToIdentity("l3"));
            System.out.println("l3: Activating");
            adapter.activate();
	    System.out.println("l3: Waiting for shutdown");
            ic.waitForShutdown();
	    System.out.println("l3: Got shutdown");
        } catch (Ice.LocalException e) {
            e.printStackTrace();
            status = 1;
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
            status = 1;
        }
        if (ic != null) {
            try {
		System.out.println("l3: calling Communicator::destroy");
                ic.destroy();
		System.out.println("l3: return from Communicator::destroy");
            } catch (Exception e) {
                e.printStackTrace();
                status = 1;
            }
        }
        System.out.println("l3: exit with "+status);
        System.exit(status);
    }

    class l3I extends _l3interfaceDisp {
        public String l3(String rs, Ice.Current current)
        {
            System.out.println("l3: l3I::l3 entered");
            return rs;
        }
    }
}
