package MyIceModule;

public class t1 {
    public static void main(String[] args)
    {
        t1 lgd = new t1();
        lgd.run(args);
    }

    void run(String[] args)
    {
        int status = 0;
        Ice.Communicator ic = null;
        try {
            ic = Ice.Util.initialize(args);
            String proxystring = "l1@l1.l1"; 
            Ice.ObjectPrx base = ic.stringToProxy(proxystring);
            l1interfacePrx prx = l1interfacePrxHelper.checkedCast(base);
            if(prx ==null) {
                System.out.println(
                    "t1: Invalid Proxy:"+proxystring);
                throw new Error("Invalid proxy");
            }
            System.out.println("l1 returned "+prx.l1("Hello World"));
        } catch (Ice.LocalException e) {
            e.printStackTrace();
            status = 1;
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
            status = 1;
        }
        if (ic != null) {
            try {
                ic.destroy();
            } catch (Exception e) {
                e.printStackTrace();
                status = 1;
            }
        }
        System.exit(status);
    }

}
