package MyIceModule;

public class t3 {
    public static void main(String[] args)
    {
        t3 lgd = new t3();
        lgd.run(args);
    }

    void run(String[] args)
    {
        int status = 0;
        Ice.Communicator ic = null;
        try {
            ic = Ice.Util.initialize(args);
            String proxystring = "l3@l3.l3"; 
            Ice.ObjectPrx base = ic.stringToProxy(proxystring);
            l3interfacePrx prx = l3interfacePrxHelper.checkedCast(base);
            if(prx ==null) {
                System.out.println(
                    "t3: Invalid Proxy:"+proxystring);
                throw new Error("Invalid proxy");
            }
            System.out.println("l3 returned "+prx.l3("Hello World"));
        } catch (Ice.LocalException e) {
            e.printStackTrace();
            status = 1;
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
            status = 1;
        }
        if (ic != null) {
            try {
                ic.destroy();
            } catch (Exception e) {
                e.printStackTrace();
                status = 1;
            }
        }
        System.exit(status);
    }

}
